Welcome to mirror list, hosted at ThFree Co, Russian Federation.

cygwin.com/git/newlib-cygwin.git - Unnamed repository; edit this file 'description' to name the repository.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
Diffstat (limited to 'Makefile.tpl')
-rw-r--r--Makefile.tpl1000
1 files changed, 532 insertions, 468 deletions
diff --git a/Makefile.tpl b/Makefile.tpl
index 274474a5c..ea0de59ed 100644
--- a/Makefile.tpl
+++ b/Makefile.tpl
@@ -6,7 +6,7 @@ in
#
# Makefile for directory with subdirs to build.
# Copyright (C) 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-# 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software Foundation
+# 1999, 2000, 2001, 2002, 2003, 2004 Free Software Foundation
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@@ -20,7 +20,7 @@ in
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# -------------------------------
@@ -87,11 +87,13 @@ GDB_NLM_DEPS =
# the libraries.
RPATH_ENVVAR = @RPATH_ENVVAR@
+# This is the list of directories to be built for the build system.
+BUILD_CONFIGDIRS = libiberty
# Build programs are put under this directory.
BUILD_SUBDIR = @build_subdir@
# This is set by the configure script to the arguments to use when configuring
# directories built for the build system.
-BUILD_CONFIGARGS = @build_configargs@ --with-build-subdir="$(BUILD_SUBDIR)"
+BUILD_CONFIGARGS = @build_configargs@
# This is the list of variables to export in the environment when
# configuring any subdirectory. It must also be exported whenever
@@ -134,8 +136,7 @@ HOST_CONFIGARGS = @host_configargs@
# with srcdir=..
HOST_SUBDIR = @host_subdir@
# This is the list of variables to export in the environment when
-# configuring subdirectories for the host system. We need to pass
-# some to the GCC configure because of its hybrid host/target nature.
+# configuring subdirectories for the host system.
HOST_EXPORTS = \
$(BASE_EXPORTS) \
CC="$(CC)"; export CC; \
@@ -154,23 +155,14 @@ HOST_EXPORTS = \
WINDRES="$(WINDRES)"; export WINDRES; \
OBJCOPY="$(OBJCOPY)"; export OBJCOPY; \
OBJDUMP="$(OBJDUMP)"; export OBJDUMP; \
- AR_FOR_TARGET="$(AR_FOR_TARGET)"; export AR_FOR_TARGET; \
- AS_FOR_TARGET="$(AS_FOR_TARGET)"; export AS_FOR_TARGET; \
- GCC_FOR_TARGET="$(GCC_FOR_TARGET)"; export GCC_FOR_TARGET; \
- LD_FOR_TARGET="$(LD_FOR_TARGET)"; export LD_FOR_TARGET; \
- NM_FOR_TARGET="$(NM_FOR_TARGET)"; export NM_FOR_TARGET; \
- OBJDUMP_FOR_TARGET="$(OBJDUMP_FOR_TARGET)"; export OBJDUMP_FOR_TARGET; \
- RANLIB_FOR_TARGET="$(RANLIB_FOR_TARGET)"; export RANLIB_FOR_TARGET; \
TOPLEVEL_CONFIGURE_ARGUMENTS="$(TOPLEVEL_CONFIGURE_ARGUMENTS)"; export TOPLEVEL_CONFIGURE_ARGUMENTS; \
GMPLIBS="$(HOST_GMPLIBS)"; export GMPLIBS; \
GMPINC="$(HOST_GMPINC)"; export GMPINC; \
-@if gcc-bootstrap
- $(RPATH_ENVVAR)=`echo "$(TARGET_LIB_PATH)$$$(RPATH_ENVVAR)" | sed 's,::*,:,g;s,^:*,,;s,:*$$,,'`; export $(RPATH_ENVVAR); \
-@endif gcc-bootstrap
$(RPATH_ENVVAR)=`echo "$(HOST_LIB_PATH)$$$(RPATH_ENVVAR)" | sed 's,::*,:,g;s,^:*,,;s,:*$$,,'`; export $(RPATH_ENVVAR);
# Similar, for later GCC stages.
-POSTSTAGE1_HOST_EXPORTS = \
+STAGE_HOST_EXPORTS = \
+ $(RPATH_ENVVAR)=`echo "$(TARGET_LIB_PATH)$$$(RPATH_ENVVAR)" | sed 's,::*,:,g;s,^:*,,;s,:*$$,,'`; export $(RPATH_ENVVAR); \
$(HOST_EXPORTS) \
CC="$(STAGE_CC_WRAPPER) $$r/$(HOST_SUBDIR)/prev-gcc/xgcc$(exeext) \
-B$$r/$(HOST_SUBDIR)/prev-gcc/ -B$(build_tooldir)/bin/"; export CC; \
@@ -179,17 +171,20 @@ POSTSTAGE1_HOST_EXPORTS = \
-B$$r/$(HOST_SUBDIR)/prev-gcc/ \
-B$(build_tooldir)/bin/"; export CC_FOR_BUILD;
+# This is set by the configure script to the list of directories which
+# should be built using the target tools.
+TARGET_CONFIGDIRS = @target_configdirs@
# Target libraries are put under this directory:
TARGET_SUBDIR = @target_subdir@
# This is set by the configure script to the arguments to use when configuring
# directories built for the target.
-TARGET_CONFIGARGS = @target_configargs@ --with-target-subdir="$(TARGET_SUBDIR)"
+TARGET_CONFIGARGS = @target_configargs@
# This is the list of variables to export in the environment when
# configuring subdirectories for the host system.
BASE_TARGET_EXPORTS = \
$(BASE_EXPORTS) \
AR="$(AR_FOR_TARGET)"; export AR; \
- AS="$(COMPILER_AS_FOR_TARGET)"; export AS; \
+ AS="$(AS_FOR_TARGET)"; export AS; \
CC="$(CC_FOR_TARGET)"; export CC; \
CFLAGS="$(CFLAGS_FOR_TARGET)"; export CFLAGS; \
CONFIG_SHELL="$(SHELL)"; export CONFIG_SHELL; \
@@ -198,13 +193,10 @@ BASE_TARGET_EXPORTS = \
GCJ="$(GCJ_FOR_TARGET)"; export GCJ; \
GFORTRAN="$(GFORTRAN_FOR_TARGET)"; export GFORTRAN; \
DLLTOOL="$(DLLTOOL_FOR_TARGET)"; export DLLTOOL; \
- LD="$(COMPILER_LD_FOR_TARGET)"; export LD; \
+ LD="$(LD_FOR_TARGET)"; export LD; \
LDFLAGS="$(LDFLAGS_FOR_TARGET)"; export LDFLAGS; \
- LIPO="$(LIPO_FOR_TARGET)"; export LIPO; \
- NM="$(COMPILER_NM_FOR_TARGET)"; export NM; \
- OBJDUMP="$(OBJDUMP_FOR_TARGET)"; export OBJDUMP; \
+ NM="$(NM_FOR_TARGET)"; export NM; \
RANLIB="$(RANLIB_FOR_TARGET)"; export RANLIB; \
- STRIP="$(STRIP_FOR_TARGET)"; export STRIP; \
WINDRES="$(WINDRES_FOR_TARGET)"; export WINDRES; \
$(RPATH_ENVVAR)=`echo "$(HOST_LIB_PATH)$(TARGET_LIB_PATH)$$$(RPATH_ENVVAR)" | sed 's,::*,:,g;s,^:*,,;s,:*$$,,'`; export $(RPATH_ENVVAR);
@@ -250,16 +242,48 @@ BUILD_PREFIX_1 = @BUILD_PREFIX_1@
# Flags to pass to stage2 and later makes. They are defined
# here so that they can be overridden by Makefile fragments.
BOOT_CFLAGS= -g -O2
-BOOT_LDFLAGS=
-BISON = @BISON@
-YACC = @YACC@
-FLEX = @FLEX@
-LEX = @LEX@
-M4 = @M4@
-MAKEINFO = @MAKEINFO@
-EXPECT = @EXPECT@
-RUNTEST = @RUNTEST@
+CONFIGURED_BISON = @CONFIGURED_BISON@
+BISON = `if [ -f $$r/$(BUILD_SUBDIR)/bison/tests/bison ] ; then \
+ echo $$r/$(BUILD_SUBDIR)/bison/tests/bison ; \
+ else \
+ echo ${CONFIGURED_BISON} ; \
+ fi`
+
+CONFIGURED_YACC = @CONFIGURED_YACC@
+YACC = `if [ -f $$r/$(BUILD_SUBDIR)/bison/tests/bison ] ; then \
+ echo $$r/$(BUILD_SUBDIR)/bison/tests/bison -y ; \
+ elif [ -f $$r/$(BUILD_SUBDIR)/byacc/byacc ] ; then \
+ echo $$r/$(BUILD_SUBDIR)/byacc/byacc ; \
+ else \
+ echo ${CONFIGURED_YACC} ; \
+ fi`
+
+CONFIGURED_FLEX = @CONFIGURED_FLEX@
+FLEX = `if [ -f $$r/$(BUILD_SUBDIR)/flex/flex ] ; \
+ then echo $$r/$(BUILD_SUBDIR)/flex/flex ; \
+ else echo ${CONFIGURED_FLEX} ; fi`
+
+CONFIGURED_LEX = @CONFIGURED_LEX@
+LEX = `if [ -f $$r/$(BUILD_SUBDIR)/flex/flex ] ; \
+ then echo $$r/$(BUILD_SUBDIR)/flex/flex ; \
+ else echo ${CONFIGURED_LEX} ; fi`
+
+CONFIGURED_M4 = @CONFIGURED_M4@
+M4 = `if [ -f $$r/$(BUILD_SUBDIR)/m4/m4 ] ; \
+ then echo $$r/$(BUILD_SUBDIR)/m4/m4 ; \
+ else echo ${CONFIGURED_M4} ; fi`
+
+# For an installed makeinfo, we require it to be from texinfo 4.2 or
+# higher, else we use the "missing" dummy. We also pass the subdirectory
+# makeinfo even if only the Makefile is there, because Texinfo builds its
+# manual when made, and it requires its own version.
+CONFIGURED_MAKEINFO = @CONFIGURED_MAKEINFO@
+MAKEINFO = `if [ -f $$r/$(BUILD_SUBDIR)/texinfo/makeinfo/Makefile ] ; \
+ then echo $$r/$(BUILD_SUBDIR)/texinfo/makeinfo/makeinfo ; \
+ else if (${CONFIGURED_MAKEINFO} --version \
+ | egrep 'texinfo[^0-9]*([1-3][0-9]|4\.[2-9]|[5-9])') >/dev/null 2>&1; \
+ then echo ${CONFIGURED_MAKEINFO}; else echo $$s/missing makeinfo; fi; fi`
# This just becomes part of the MAKEINFO definition passed down to
# sub-makes. It lets flags be given on the command line while still
@@ -267,29 +291,43 @@ RUNTEST = @RUNTEST@
# (Default to avoid splitting info files by setting the threshold high.)
MAKEINFOFLAGS = --split-size=5000000
+# FIXME: expect may become a build tool?
+EXPECT = `if [ -f $$r/$(HOST_SUBDIR)/expect/expect ] ; \
+ then echo $$r/$(HOST_SUBDIR)/expect/expect ; \
+ else echo expect ; fi`
+
+RUNTEST = `if [ -f $$s/dejagnu/runtest ] ; \
+ then echo $$s/dejagnu/runtest ; \
+ else echo runtest ; fi`
+
# ---------------------------------------------
# Programs producing files for the HOST machine
# ---------------------------------------------
AS = @AS@
+
AR = @AR@
AR_FLAGS = rc
+
CC = @CC@
+CFLAGS = @CFLAGS@
+LIBCFLAGS = $(CFLAGS)
+
CXX = @CXX@
+CXXFLAGS = @CXXFLAGS@
+LIBCXXFLAGS = $(CXXFLAGS) -fno-implicit-templates
+
DLLTOOL = @DLLTOOL@
-LD = @LD@
-LIPO = @LIPO@
+
NM = @NM@
-OBJDUMP = @OBJDUMP@
+
+LD = @LD@
+LDFLAGS =
+
RANLIB = @RANLIB@
-STRIP = @STRIP@
+
WINDRES = @WINDRES@
-CFLAGS = @CFLAGS@
-LDFLAGS =
-LIBCFLAGS = $(CFLAGS)
-CXXFLAGS = @CXXFLAGS@
-LIBCXXFLAGS = $(CXXFLAGS) -fno-implicit-templates
PICFLAG =
# -----------------------------------------------
@@ -299,42 +337,133 @@ PICFLAG =
FLAGS_FOR_TARGET = @FLAGS_FOR_TARGET@
AR_FOR_TARGET=@AR_FOR_TARGET@
-AS_FOR_TARGET=@AS_FOR_TARGET@
-CC_FOR_TARGET=$(STAGE_CC_WRAPPER) @CC_FOR_TARGET@ $(FLAGS_FOR_TARGET)
+CONFIGURED_AR_FOR_TARGET=@CONFIGURED_AR_FOR_TARGET@
+USUAL_AR_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/binutils/ar ] ; then \
+ echo $$r/$(HOST_SUBDIR)/binutils/ar ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(AR); \
+ else \
+ echo $(CONFIGURED_AR_FOR_TARGET) ; \
+ fi; \
+ fi`
+AS_FOR_TARGET=@AS_FOR_TARGET@
+CONFIGURED_AS_FOR_TARGET=@CONFIGURED_AS_FOR_TARGET@
+USUAL_AS_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/gas/as-new ] ; then \
+ echo $$r/$(HOST_SUBDIR)/gas/as-new ; \
+ elif [ -f $$r/$(HOST_SUBDIR)/gcc/xgcc ]; then \
+ $(CC_FOR_TARGET) -print-prog-name=as ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(AS); \
+ else \
+ echo $(CONFIGURED_AS_FOR_TARGET) ; \
+ fi; \
+ fi`
+
+CC_FOR_TARGET = @CC_FOR_TARGET@
+# During gcc bootstrap, if we use some random cc for stage1 then
+# CFLAGS will be just -g. We want to ensure that TARGET libraries
+# (which we know are built with gcc) are built with optimizations so
+# prepend -O2 when setting CFLAGS_FOR_TARGET.
+CFLAGS_FOR_TARGET = -O2 $(CFLAGS)
# If GCC_FOR_TARGET is not overriden on the command line, then this
# variable is passed down to the gcc Makefile, where it is used to
# build libgcc2.a. We define it here so that it can itself be
# overridden on the command line.
-GCC_FOR_TARGET=$(STAGE_CC_WRAPPER) @GCC_FOR_TARGET@ $(FLAGS_FOR_TARGET)
-CXX_FOR_TARGET=$(STAGE_CC_WRAPPER) @CXX_FOR_TARGET@ $(FLAGS_FOR_TARGET)
-RAW_CXX_FOR_TARGET=$(STAGE_CC_WRAPPER) @RAW_CXX_FOR_TARGET@ $(FLAGS_FOR_TARGET)
-GCJ_FOR_TARGET=$(STAGE_CC_WRAPPER) @GCJ_FOR_TARGET@ $(FLAGS_FOR_TARGET)
-GFORTRAN_FOR_TARGET=$(STAGE_CC_WRAPPER) @GFORTRAN_FOR_TARGET@ $(FLAGS_FOR_TARGET)
+GCC_FOR_TARGET=@GCC_FOR_TARGET@
+USUAL_GCC_FOR_TARGET = $(STAGE_CC_WRAPPER) \
+ $$r/$(HOST_SUBDIR)/gcc/xgcc -B$$r/$(HOST_SUBDIR)/gcc/ $(FLAGS_FOR_TARGET)
+LIBCFLAGS_FOR_TARGET = $(CFLAGS_FOR_TARGET)
+
+CXX_FOR_TARGET = @CXX_FOR_TARGET@
+RAW_CXX_FOR_TARGET = @RAW_CXX_FOR_TARGET@
+CXX_FOR_TARGET_FOR_RECURSIVE_MAKE = @CXX_FOR_TARGET_FOR_RECURSIVE_MAKE@
+RAW_CXX_FOR_TARGET_FOR_RECURSIVE_MAKE = @RAW_CXX_FOR_TARGET_FOR_RECURSIVE_MAKE@
+CXXFLAGS_FOR_TARGET = $(CXXFLAGS)
+LIBCXXFLAGS_FOR_TARGET = $(CXXFLAGS_FOR_TARGET) -fno-implicit-templates
+
DLLTOOL_FOR_TARGET=@DLLTOOL_FOR_TARGET@
+CONFIGURED_DLLTOOL_FOR_TARGET=@CONFIGURED_DLLTOOL_FOR_TARGET@
+USUAL_DLLTOOL_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/binutils/dlltool ] ; then \
+ echo $$r/$(HOST_SUBDIR)/binutils/dlltool ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(DLLTOOL); \
+ else \
+ echo $(CONFIGURED_DLLTOOL_FOR_TARGET) ; \
+ fi; \
+ fi`
+
+GCJ_FOR_TARGET = @GCJ_FOR_TARGET@
+GFORTRAN_FOR_TARGET = @GFORTRAN_FOR_TARGET@
+
LD_FOR_TARGET=@LD_FOR_TARGET@
+CONFIGURED_LD_FOR_TARGET=@CONFIGURED_LD_FOR_TARGET@
+USUAL_LD_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/ld/ld-new ] ; then \
+ echo $$r/$(HOST_SUBDIR)/ld/ld-new ; \
+ elif [ -f $$r/$(HOST_SUBDIR)/gcc/xgcc ]; then \
+ $(CC_FOR_TARGET) -print-prog-name=ld ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(LD); \
+ else \
+ echo $(CONFIGURED_LD_FOR_TARGET) ; \
+ fi; \
+ fi`
+
+LDFLAGS_FOR_TARGET =
-LIPO_FOR_TARGET=@LIPO_FOR_TARGET@
NM_FOR_TARGET=@NM_FOR_TARGET@
-OBJDUMP_FOR_TARGET=@OBJDUMP_FOR_TARGET@
+CONFIGURED_NM_FOR_TARGET=@CONFIGURED_NM_FOR_TARGET@
+USUAL_NM_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/binutils/nm-new ] ; then \
+ echo $$r/$(HOST_SUBDIR)/binutils/nm-new ; \
+ elif [ -f $$r/$(HOST_SUBDIR)/gcc/xgcc ]; then \
+ $(CC_FOR_TARGET) -print-prog-name=nm ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(NM); \
+ else \
+ echo $(CONFIGURED_NM_FOR_TARGET) ; \
+ fi; \
+ fi`
+
RANLIB_FOR_TARGET=@RANLIB_FOR_TARGET@
-STRIP_FOR_TARGET=@STRIP_FOR_TARGET@
-WINDRES_FOR_TARGET=@WINDRES_FOR_TARGET@
+CONFIGURED_RANLIB_FOR_TARGET=@CONFIGURED_RANLIB_FOR_TARGET@
+USUAL_RANLIB_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/binutils/ranlib ] ; then \
+ echo $$r/$(HOST_SUBDIR)/binutils/ranlib ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ if [ x'$(RANLIB)' != x ]; then \
+ echo $(RANLIB); \
+ else \
+ echo ranlib; \
+ fi; \
+ else \
+ echo $(CONFIGURED_RANLIB_FOR_TARGET) ; \
+ fi; \
+ fi`
-COMPILER_AS_FOR_TARGET=@COMPILER_AS_FOR_TARGET@
-COMPILER_LD_FOR_TARGET=@COMPILER_LD_FOR_TARGET@
-COMPILER_NM_FOR_TARGET=@COMPILER_NM_FOR_TARGET@
+WINDRES_FOR_TARGET=@WINDRES_FOR_TARGET@
+CONFIGURED_WINDRES_FOR_TARGET=@CONFIGURED_WINDRES_FOR_TARGET@
+USUAL_WINDRES_FOR_TARGET = ` \
+ if [ -f $$r/$(HOST_SUBDIR)/binutils/windres ] ; then \
+ echo $$r/$(HOST_SUBDIR)/binutils/windres ; \
+ else \
+ if [ '$(host)' = '$(target)' ] ; then \
+ echo $(WINDRES); \
+ else \
+ echo $(CONFIGURED_WINDRES_FOR_TARGET) ; \
+ fi; \
+ fi`
-# During gcc bootstrap, if we use some random cc for stage1 then
-# CFLAGS will be just -g. We want to ensure that TARGET libraries
-# (which we know are built with gcc) are built with optimizations so
-# prepend -O2 when setting CFLAGS_FOR_TARGET.
-CFLAGS_FOR_TARGET = -O2 $(CFLAGS) $(SYSROOT_CFLAGS_FOR_TARGET)
-SYSROOT_CFLAGS_FOR_TARGET = @SYSROOT_CFLAGS_FOR_TARGET@
-CXXFLAGS_FOR_TARGET = $(CXXFLAGS) $(SYSROOT_CFLAGS_FOR_TARGET)
-LIBCFLAGS_FOR_TARGET = $(CFLAGS_FOR_TARGET)
-LIBCXXFLAGS_FOR_TARGET = $(CXXFLAGS_FOR_TARGET) -fno-implicit-templates
-LDFLAGS_FOR_TARGET =
PICFLAG_FOR_TARGET =
# ------------------------------------
@@ -343,7 +472,7 @@ PICFLAG_FOR_TARGET =
# The first rule in the file had better be this one. Don't put any above it.
# This lives here to allow makefile fragments to contain dependencies.
-all:
+@default_target@:
#### host and target specific makefile fragments come in here.
@target_makefile_frag@
@@ -384,14 +513,21 @@ HOST_LIB_PATH_[+module+] = \
[+ ENDIF lib_path +][+ ENDFOR host_modules +]
# Flags to pass down to all sub-makes.
-BASE_FLAGS_TO_PASS =[+ FOR flags_to_pass +][+ IF optional +] \
- "`echo '[+flag+]=$([+flag+])' | sed -e s'/[^=][^=]*=$$/XFOO=/'`"[+ ELSE optional +] \
- "[+flag+]=$([+flag+])"[+ ENDIF optional+][+ ENDFOR flags_to_pass +] \
+BASE_FLAGS_TO_PASS = [+ FOR flags_to_pass +]\
+ "[+flag+]=$([+flag+])" [+ ENDFOR flags_to_pass +]\
"CONFIG_SHELL=$(SHELL)" \
"MAKEINFO=$(MAKEINFO) $(MAKEINFOFLAGS)"
-# We leave this in just in case, but it is not needed anymore.
-RECURSE_FLAGS_TO_PASS = $(BASE_FLAGS_TO_PASS)
+# For any flags above that may contain shell code that varies from one
+# target library to another. When doing recursive invocations of the
+# top-level Makefile, we don't want the outer make to evaluate them,
+# so we pass these variables down unchanged. They must not contain
+# single nor double quotes.
+RECURSE_FLAGS = \
+ CXX_FOR_TARGET='$(CXX_FOR_TARGET_FOR_RECURSIVE_MAKE)' \
+ RAW_CXX_FOR_TARGET='$(RAW_CXX_FOR_TARGET_FOR_RECURSIVE_MAKE)' \
+
+RECURSE_FLAGS_TO_PASS = $(BASE_FLAGS_TO_PASS) $(RECURSE_FLAGS)
# Flags to pass down to most sub-makes, in which we're building with
# the host environment.
@@ -402,11 +538,8 @@ EXTRA_HOST_FLAGS = \
'CXX=$(CXX)' \
'DLLTOOL=$(DLLTOOL)' \
'LD=$(LD)' \
- 'LIPO=$(LIPO)' \
'NM=$(NM)' \
- 'OBJDUMP=$(OBJDUMP)' \
'RANLIB=$(RANLIB)' \
- 'STRIP=$(STRIP)' \
'WINDRES=$(WINDRES)'
FLAGS_TO_PASS = $(BASE_FLAGS_TO_PASS) $(EXTRA_HOST_FLAGS)
@@ -424,23 +557,20 @@ X11_FLAGS_TO_PASS = \
'X11_EXTRA_LIBS=$(X11_EXTRA_LIBS)'
# Flags to pass down to makes which are built with the target environment.
-# The double $ decreases the length of the command line; those variables
-# are set in BASE_FLAGS_TO_PASS, and the sub-make will expand them. The
-# COMPILER_ prefixed variables are not passed down so we expand them here.
+# The double $ decreases the length of the command line; the variables
+# are set in BASE_FLAGS_TO_PASS, and the sub-make will expand them.
EXTRA_TARGET_FLAGS = \
'AR=$$(AR_FOR_TARGET)' \
- 'AS=$(COMPILER_AS_FOR_TARGET)' \
+ 'AS=$$(AS_FOR_TARGET)' \
'CC=$$(CC_FOR_TARGET)' \
'CFLAGS=$$(CFLAGS_FOR_TARGET)' \
'CXX=$$(CXX_FOR_TARGET)' \
'CXXFLAGS=$$(CXXFLAGS_FOR_TARGET)' \
'DLLTOOL=$$(DLLTOOL_FOR_TARGET)' \
- 'LD=$(COMPILER_LD_FOR_TARGET)' \
- 'LDFLAGS=$$(LDFLAGS_FOR_TARGET)' \
+ 'LD=$$(LD_FOR_TARGET)' \
'LIBCFLAGS=$$(LIBCFLAGS_FOR_TARGET)' \
'LIBCXXFLAGS=$$(LIBCXXFLAGS_FOR_TARGET)' \
- 'NM=$(COMPILER_NM_FOR_TARGET)' \
- 'OBJDUMP=$$(OBJDUMP_FOR_TARGET)' \
+ 'NM=$$(NM_FOR_TARGET)' \
'RANLIB=$$(RANLIB_FOR_TARGET)' \
'WINDRES=$$(WINDRES_FOR_TARGET)'
@@ -453,12 +583,19 @@ TARGET_FLAGS_TO_PASS = $(BASE_FLAGS_TO_PASS) $(EXTRA_TARGET_FLAGS)
# The BUILD_* variables are a special case, which are used for the gcc
# cross-building scheme.
EXTRA_GCC_FLAGS = \
+ 'BUILD_PREFIX=$(BUILD_PREFIX)' \
+ 'BUILD_PREFIX_1=$(BUILD_PREFIX_1)' \
"GCC_FOR_TARGET=$(GCC_FOR_TARGET)" \
+ "CFLAGS_FOR_BUILD=$(CFLAGS_FOR_BUILD)" \
+ "`echo 'LANGUAGES=$(LANGUAGES)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
"`echo 'STMP_FIXPROTO=$(STMP_FIXPROTO)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
"`echo 'LIMITS_H_TEST=$(LIMITS_H_TEST)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
"`echo 'LIBGCC2_CFLAGS=$(LIBGCC2_CFLAGS)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
"`echo 'LIBGCC2_DEBUG_CFLAGS=$(LIBGCC2_DEBUG_CFLAGS)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
- "`echo 'LIBGCC2_INCLUDES=$(LIBGCC2_INCLUDES)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`"
+ "`echo 'LIBGCC2_INCLUDES=$(LIBGCC2_INCLUDES)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
+ "`echo 'STAGE1_CFLAGS=$(STAGE1_CFLAGS)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
+ "`echo 'BOOT_CFLAGS=$(BOOT_CFLAGS)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`" \
+ "`echo 'BOOT_ADAFLAGS=$(BOOT_ADAFLAGS)' | sed -e s'/[^=][^=]*=$$/XFOO=/'`"
GCC_FLAGS_TO_PASS = $(BASE_FLAGS_TO_PASS) $(EXTRA_HOST_FLAGS) $(EXTRA_GCC_FLAGS)
@@ -475,37 +612,23 @@ configure-target: [+
# The target built for a native non-bootstrap build.
.PHONY: all
-all:
-@if gcc-bootstrap
- [ -f stage_final ] || echo stage3 > stage_final
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) `cat stage_final`-bubble
-@endif gcc-bootstrap
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- if [ -f stage_last ]; then \
- $(MAKE) $(TARGET_FLAGS_TO_PASS) all-host all-target; \
- else \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) all-host all-target; \
- fi
+all: unstage all-host all-target stage
.PHONY: all-build
-[+ FOR build_modules +]
-all-build: maybe-all-build-[+module+][+ ENDFOR build_modules +]
-
+all-build: [+
+ FOR build_modules +] \
+ maybe-all-build-[+module+][+
+ ENDFOR build_modules +]
.PHONY: all-host
-[+ FOR host_modules +][+ IF bootstrap +]
-@if [+module+]-no-bootstrap[+ ENDIF bootstrap +]
-all-host: maybe-all-[+module+][+ IF bootstrap +]
-@endif [+module+]-no-bootstrap[+ ENDIF bootstrap +][+ ENDFOR host_modules +]
-
+all-host: [+
+ FOR host_modules +] \
+ maybe-all-[+module+][+
+ ENDFOR host_modules +]
.PHONY: all-target
-[+ FOR target_modules +][+ IF bootstrap +]
-@if [+module+]-no-bootstrap[+ ENDIF bootstrap +]
-all-target: maybe-all-target-[+module+][+ IF bootstrap +]
-@endif [+module+]-no-bootstrap[+ ENDIF bootstrap +][+ ENDFOR target_modules +]
+all-target: [+
+ FOR target_modules +] \
+ maybe-all-target-[+module+][+
+ ENDFOR target_modules +]
# Do a target for all the subdirectories. A ``make do-X'' will do a
# ``make X'' in all subdirectories (because, in general, there is a
@@ -513,21 +636,19 @@ all-target: maybe-all-target-[+module+][+ IF bootstrap +]
# but it may do additional work as well).
[+ FOR recursive_targets +]
.PHONY: do-[+make_target+]
-do-[+make_target+]:
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) [+make_target+]-host \
- [+make_target+]-target
-
+do-[+make_target+]: unstage [+make_target+]-host [+make_target+]-target stage
.PHONY: [+make_target+]-host
-[+ FOR host_modules +]
-[+make_target+]-host: maybe-[+make_target+]-[+module+][+ ENDFOR host_modules +]
+[+make_target+]-host: [+
+ FOR host_modules +] \
+ maybe-[+make_target+]-[+module+][+
+ ENDFOR host_modules +]
.PHONY: [+make_target+]-target
-[+ FOR target_modules +]
-[+make_target+]-target: maybe-[+make_target+]-target-[+module+][+ ENDFOR target_modules +]
+[+make_target+]-target: [+
+ FOR target_modules +] \
+ maybe-[+make_target+]-target-[+module+][+
+ ENDFOR target_modules +]
[+ ENDFOR recursive_targets +]
# Here are the targets which correspond to the do-X targets.
@@ -555,7 +676,7 @@ local-clean:
local-distclean:
-rm -f Makefile config.status config.cache mh-frag mt-frag
- -rm -f maybedep.tmp serdep.tmp
+ -rm -f multilib.out multilib.tmp maybedep.tmp serdep.tmp
-if [ "$(TARGET_SUBDIR)" != "." ]; then \
rm -rf $(TARGET_SUBDIR); \
else true; fi
@@ -580,10 +701,14 @@ maintainer-clean: local-maintainer-clean do-maintainer-clean local-clean
maintainer-clean: local-distclean
realclean: maintainer-clean
-# Extra dependency for clean-target, owing to the mixed nature of gcc.
+# Extra dependency for clean-target, owing to the mixed nature of gcc
clean-target: clean-target-libgcc
clean-target-libgcc:
- test ! -d gcc || (cd gcc && $(MAKE) $@)
+ test ! -d gcc/libgcc || \
+ (cd gcc/libgcc && find . -type d -print) | \
+ while read d; do rm -f gcc/$$d/libgcc.a || : ; done
+ -rm -rf gcc/libgcc
+ -rm -f gcc/stmp-dirs
# Check target.
@@ -591,23 +716,13 @@ clean-target-libgcc:
check: do-check
# Only include modules actually being configured and built.
-.PHONY: check-host
-check-host: [+
+do-check: unstage [+
FOR host_modules +] \
maybe-check-[+module+][+
- ENDFOR host_modules +]
-
-.PHONY: check-target
-check-target: [+
+ ENDFOR host_modules +][+
FOR target_modules +] \
maybe-check-target-[+module+][+
- ENDFOR target_modules +]
-
-do-check:
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) check-host check-target
+ ENDFOR target_modules +] stage
# Automated reporting of test results.
@@ -633,11 +748,7 @@ mail-report-with-warnings.log: warning.log
# Installation targets.
.PHONY: install uninstall
-install:
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) installdirs install-host install-target
+install: installdirs install-host install-target
.PHONY: install-host-nogcc
install-host-nogcc: [+
@@ -664,7 +775,6 @@ uninstall:
install.all: install-no-fixedincludes
@if [ -f ./gcc/Makefile ] ; then \
r=`${PWD_COMMAND}` ; export r ; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
$(HOST_EXPORTS) \
(cd ./gcc && \
$(MAKE) $(FLAGS_TO_PASS) install-headers) ; \
@@ -708,184 +818,92 @@ etags tags: TAGS
# built are.
TAGS: do-TAGS
-# ------------------------------------
-# Macros for configure and all targets
-# ------------------------------------
-
-[+ DEFINE configure +]
-.PHONY: configure-[+prefix+][+module+] maybe-configure-[+prefix+][+module+]
-maybe-configure-[+prefix+][+module+]:
-@if [+prefix+][+module+]
-maybe-configure-[+prefix+][+module+]: configure-[+prefix+][+module+]
-configure-[+prefix+][+module+]: [+ IF bootstrap +]
-@endif [+prefix+][+module+]
-@if [+prefix+][+module+]-bootstrap
- @if test -f stage_last; then $(unstage); else $(MAKE) stage1-start; fi
-@endif [+prefix+][+module+]-bootstrap
-@if [+prefix+][+module+][+ ELSE bootstrap +]
- @: $(MAKE); $(unstage)[+ ENDIF bootstrap +]
- @r=`${PWD_COMMAND}`; export r; \
+# --------------------------------------
+# Modules which run on the build machine
+# --------------------------------------
+[+ FOR build_modules +]
+.PHONY: configure-build-[+module+] maybe-configure-build-[+module+]
+maybe-configure-build-[+module+]:
+@if build-[+module+]
+maybe-configure-build-[+module+]: configure-build-[+module+]
+configure-build-[+module+]:
+ @test ! -f $(BUILD_SUBDIR)/[+module+]/Makefile || exit 0; \
+ $(SHELL) $(srcdir)/mkinstalldirs $(BUILD_SUBDIR)/[+module+] ; \
+ r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- [+ IF check_multilibs
- +]echo "Checking multilib configuration for [+module+]..."; \
- $(SHELL) $(srcdir)/mkinstalldirs [+subdir+]/[+module+] ; \
- $(CC_FOR_TARGET) --print-multi-lib > [+subdir+]/[+module+]/multilib.tmp 2> /dev/null ; \
- if test -r [+subdir+]/[+module+]/multilib.out; then \
- if cmp -s [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; then \
- rm -f [+subdir+]/[+module+]/multilib.tmp; \
- else \
- rm -f [+subdir+]/[+module+]/Makefile; \
- mv [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; \
- fi; \
- else \
- mv [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; \
- fi; \
- [+ ENDIF check_multilibs +]test ! -f [+subdir+]/[+module+]/Makefile || exit 0; \
- $(SHELL) $(srcdir)/mkinstalldirs [+subdir+]/[+module+] ; \
- [+exports+] \
- echo Configuring in [+subdir+]/[+module+]; \
- cd "[+subdir+]/[+module+]" || exit 1; \
+ $(BUILD_EXPORTS) \
+ echo Configuring in $(BUILD_SUBDIR)/[+module+]; \
+ cd "$(BUILD_SUBDIR)/[+module+]" || exit 1; \
case $(srcdir) in \
/* | [A-Za-z]:[\\/]*) topdir=$(srcdir) ;; \
- *) topdir=`echo [+subdir+]/[+module+]/ | \
+ *) topdir=`echo $(BUILD_SUBDIR)/[+module+]/ | \
sed -e 's,\./,,g' -e 's,[^/]*/,../,g' `$(srcdir) ;; \
esac; \
srcdiroption="--srcdir=$${topdir}/[+module+]"; \
libsrcdir="$$s/[+module+]"; \
- [+ IF no-config-site +]rm -f no-such-file || : ; \
- CONFIG_SITE=no-such-file [+ ENDIF +]$(SHELL) $${libsrcdir}/configure \
- [+args+] $${srcdiroption} [+extra_configure_flags+] \
+ rm -f no-such-file || : ; \
+ CONFIG_SITE=no-such-file $(SHELL) $${libsrcdir}/configure \
+ $(BUILD_CONFIGARGS) $${srcdiroption} \
+ --with-build-subdir="$(BUILD_SUBDIR)" [+extra_configure_flags+] \
|| exit 1
-@endif [+prefix+][+module+]
-
-[+ IF bootstrap +]
-[+ FOR bootstrap_stage +]
-.PHONY: configure-stage[+id+]-[+prefix+][+module+] maybe-configure-stage[+id+]-[+prefix+][+module+]
-maybe-configure-stage[+id+]-[+prefix+][+module+]:
-@if [+prefix+][+module+]-bootstrap
-maybe-configure-stage[+id+]-[+prefix+][+module+]: configure-stage[+id+]-[+prefix+][+module+]
-configure-stage[+id+]-[+prefix+][+module+]:
- @[ $(current_stage) = stage[+id+] ] || $(MAKE) stage[+id+]-start
- @$(SHELL) $(srcdir)/mkinstalldirs [+subdir+]/[+module+]
+@endif build-[+module+]
+
+.PHONY: all-build-[+module+] maybe-all-build-[+module+]
+maybe-all-build-[+module+]:
+@if build-[+module+]
+TARGET-build-[+module+]=[+ IF target +][+target+][+ ELSE +]all[+ ENDIF target +]
+maybe-all-build-[+module+]: all-build-[+module+]
+all-build-[+module+]: configure-build-[+module+]
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- [+ IF check_multilibs
- +]echo "Checking multilib configuration for [+module+]..."; \
- $(CC_FOR_TARGET) --print-multi-lib > [+subdir+]/[+module+]/multilib.tmp 2> /dev/null ; \
- if test -r [+subdir+]/[+module+]/multilib.out; then \
- if cmp -s [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; then \
- rm -f [+subdir+]/[+module+]/multilib.tmp; \
- else \
- rm -f [+subdir+]/[+module+]/Makefile; \
- mv [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; \
- fi; \
- else \
- mv [+subdir+]/[+module+]/multilib.tmp [+subdir+]/[+module+]/multilib.out; \
- fi; \
- [+ ENDIF check_multilibs +]test ! -f [+subdir+]/[+module+]/Makefile || exit 0; \
- [+exports+][+ IF prev +] \
- [+poststage1_exports+][+ ENDIF prev +] \
- echo Configuring stage [+id+] in [+subdir+]/[+module+] ; \
- $(SHELL) $(srcdir)/mkinstalldirs [+subdir+]/[+module+] ; \
- cd [+subdir+]/[+module+] || exit 1; \
+ $(BUILD_EXPORTS) \
+ (cd $(BUILD_SUBDIR)/[+module+] && \
+ $(MAKE) [+extra_make_flags+] $(TARGET-build-[+module+]))
+@endif build-[+module+]
+[+ ENDFOR build_modules +]
+
+# --------------------------------------
+# Modules which run on the host machine
+# --------------------------------------
+[+ FOR host_modules +]
+.PHONY: configure-[+module+] maybe-configure-[+module+]
+maybe-configure-[+module+]:
+@if [+module+]
+maybe-configure-[+module+]: configure-[+module+]
+configure-[+module+]:
+ @[+ IF bootstrap +]test -f stage_last && exit 0; \
+ [+ ENDIF bootstrap +]test ! -f $(HOST_SUBDIR)/[+module+]/Makefile || exit 0; \
+ $(SHELL) $(srcdir)/mkinstalldirs $(HOST_SUBDIR)/[+module+] ; \
+ r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
+ $(HOST_EXPORTS) \
+ echo Configuring in [+module+]; \
+ cd $(HOST_SUBDIR)/[+module+] || exit 1; \
case $(srcdir) in \
/* | [A-Za-z]:[\\/]*) topdir=$(srcdir) ;; \
- *) topdir=`echo [+subdir+]/[+module+]/ | \
+ *) topdir=`echo $(HOST_SUBDIR)/[+module+]/ | \
sed -e 's,\./,,g' -e 's,[^/]*/,../,g' `$(srcdir) ;; \
esac; \
srcdiroption="--srcdir=$${topdir}/[+module+]"; \
libsrcdir="$$s/[+module+]"; \
$(SHELL) $${libsrcdir}/configure \
- [+args+] $${srcdiroption} \
- [+stage_configure_flags+] [+extra_configure_flags+]
-@endif [+prefix+][+module+]-bootstrap
-[+ ENDFOR bootstrap_stage +]
-[+ ENDIF bootstrap +]
-[+ ENDDEF +]
-
-[+ DEFINE all +]
-.PHONY: all-[+prefix+][+module+] maybe-all-[+prefix+][+module+]
-maybe-all-[+prefix+][+module+]:
-@if [+prefix+][+module+]
-TARGET-[+prefix+][+module+]=[+
- IF target +][+target+][+ ELSE +]all[+ ENDIF target +]
-maybe-all-[+prefix+][+module+]: all-[+prefix+][+module+]
-all-[+prefix+][+module+]: configure-[+prefix+][+module+][+ IF bootstrap +]
-@endif [+prefix+][+module+]
-@if [+prefix+][+module+]-bootstrap
- @if test -f stage_last; then $(unstage); else $(MAKE) stage1-start; fi
-@endif [+prefix+][+module+]-bootstrap
-@if [+prefix+][+module+][+ ELSE bootstrap +]
- @: $(MAKE); $(unstage)[+ ENDIF bootstrap +]
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- [+exports+] \
- (cd [+subdir+]/[+module+] && \
- $(MAKE) [+args+] [+extra_make_flags+] $(TARGET-[+prefix+][+module+]))
-@endif [+prefix+][+module+]
-
-[+ IF bootstrap +]
-[+ FOR bootstrap_stage +]
-.PHONY: all-stage[+id+]-[+prefix+][+module+] maybe-all-stage[+id+]-[+prefix+][+module+]
-.PHONY: clean-stage[+id+]-[+prefix+][+module+] maybe-clean-stage[+id+]-[+prefix+][+module+]
-maybe-all-stage[+id+]-[+prefix+][+module+]:
-maybe-clean-stage[+id+]-[+prefix+][+module+]:
-@if [+prefix+][+module+]-bootstrap
-maybe-all-stage[+id+]-[+prefix+][+module+]: all-stage[+id+]-[+prefix+][+module+]
-all-stage[+id+]: all-stage[+id+]-[+prefix+][+module+]
-TARGET-stage[+id+]-[+prefix+][+module+] = $(TARGET-[+prefix+][+module+])
-all-stage[+id+]-[+prefix+][+module+]: configure-stage[+id+]-[+prefix+][+module+]
- @[ $(current_stage) = stage[+id+] ] || $(MAKE) stage[+id+]-start
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- [+exports+][+ IF prev +] \
- [+poststage1_exports+][+ ENDIF prev +] \
- cd [+subdir+]/[+module+] && \
- $(MAKE) [+args+] [+ IF prev
- +][+poststage1_args+][+ ENDIF prev
- +] [+stage_make_flags+] [+extra_make_flags+] \
- $(TARGET-stage[+id+]-[+prefix+][+module+])
-
-maybe-clean-stage[+id+]-[+prefix+][+module+]: clean-stage[+id+]-[+prefix+][+module+]
-clean-stage[+id+]: clean-stage[+id+]-[+prefix+][+module+]
-clean-stage[+id+]-[+prefix+][+module+]:
- @[ -f [+subdir+]/[+module+]/Makefile ] || [ -f [+subdir+]/stage[+id+]-[+module+]/Makefile ] \
- || exit 0 ; \
- [ $(current_stage) = stage[+id+] ] || $(MAKE) stage[+id+]-start; \
- cd [+subdir+]/[+module+] && \
- $(MAKE) [+args+] [+ IF prev +] \
- [+poststage1_args+] [+ ENDIF prev +] \
- [+stage_make_flags+] [+extra_make_flags+] clean
-@endif [+prefix+][+module+]-bootstrap
-
-[+ ENDFOR bootstrap_stage +]
-[+ ENDIF bootstrap +]
-[+ ENDDEF +]
-
-# --------------------------------------
-# Modules which run on the build machine
-# --------------------------------------
-[+ FOR build_modules +]
-[+ configure prefix="build-" subdir="$(BUILD_SUBDIR)" exports="$(BUILD_EXPORTS)"
- args="$(BUILD_CONFIGARGS)" no-config-site=true +]
-
-[+ all prefix="build-" subdir="$(BUILD_SUBDIR)" exports="$(BUILD_EXPORTS)" +]
-[+ ENDFOR build_module +]
-
-# --------------------------------------
-# Modules which run on the host machine
-# --------------------------------------
-[+ FOR host_modules +]
-[+ configure prefix="" subdir="$(HOST_SUBDIR)"
- exports="$(HOST_EXPORTS)"
- poststage1_exports="$(POSTSTAGE1_HOST_EXPORTS)"
- args="$(HOST_CONFIGARGS)" +]
+ $(HOST_CONFIGARGS) $${srcdiroption} [+extra_configure_flags+] \
+ || exit 1
+@endif [+module+]
-[+ all prefix="" subdir="$(HOST_SUBDIR)"
- exports="$(HOST_EXPORTS)"
- poststage1_exports="$(POSTSTAGE1_HOST_EXPORTS)"
- args="$(FLAGS_TO_PASS)"
- poststage1_args="$(POSTSTAGE1_FLAGS_TO_PASS)" +]
+.PHONY: all-[+module+] maybe-all-[+module+]
+maybe-all-[+module+]:
+@if [+module+]
+TARGET-[+module+]=[+ IF target +][+target+][+ ELSE +]all[+ ENDIF target +]
+maybe-all-[+module+]: all-[+module+]
+all-[+module+]: configure-[+module+]
+ @[+ IF bootstrap +]test -f stage_last && exit 0; \
+ [+ ENDIF bootstrap +]r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
+ $(HOST_EXPORTS) \
+ (cd $(HOST_SUBDIR)/[+module+] && \
+ $(MAKE) $(FLAGS_TO_PASS) [+extra_make_flags+] $(TARGET-[+module+]))
+@endif [+module+]
.PHONY: check-[+module+] maybe-check-[+module+]
maybe-check-[+module+]:
@@ -896,7 +914,6 @@ check-[+module+]:
[+ ELIF no_check_cross +]
# This module is only tested in a native toolchain.
check-[+module+]:
- @: $(MAKE); $(unstage)
@if [ '$(host)' = '$(target)' ] ; then \
r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
@@ -906,7 +923,6 @@ check-[+module+]:
fi
[+ ELSE check +]
check-[+module+]:
- @: $(MAKE); $(unstage)
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
$(HOST_EXPORTS) \
@@ -923,7 +939,6 @@ maybe-install-[+module+]: install-[+module+]
install-[+module+]:
[+ ELSE install +]
install-[+module+]: installdirs
- @: $(MAKE); $(unstage)
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
$(HOST_EXPORTS) \
@@ -946,8 +961,7 @@ maybe-[+make_target+]-[+module+]: [+make_target+]-[+module+]
FOR depend +]\
[+depend+]-[+module+] [+
ENDFOR depend +]
- @[+ IF bootstrap +][+ ELSE +]: $(MAKE); $(unstage)
- @[+ ENDIF bootstrap +][ -f ./[+module+]/Makefile ] || exit 0; \
+ @[ -f ./[+module+]/Makefile ] || exit 0; \
r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
$(HOST_EXPORTS) \
@@ -971,26 +985,63 @@ maybe-[+make_target+]-[+module+]: [+make_target+]-[+module+]
# Modules which run on the target machine
# ---------------------------------------
[+ FOR target_modules +]
+.PHONY: configure-target-[+module+] maybe-configure-target-[+module+]
+maybe-configure-target-[+module+]:
+@if target-[+module+]
+maybe-configure-target-[+module+]: configure-target-[+module+]
-[+ IF raw_cxx +]
-[+ configure prefix="target-" subdir="$(TARGET_SUBDIR)"
- check_multilibs=true
- exports="$(RAW_CXX_TARGET_EXPORTS)"
- args="$(TARGET_CONFIGARGS)" no-config-site=true +]
+# There's only one multilib.out. Cleverer subdirs shouldn't need it copied.
+$(TARGET_SUBDIR)/[+module+]/multilib.out: multilib.out
+ $(SHELL) $(srcdir)/mkinstalldirs $(TARGET_SUBDIR)/[+module+] ; \
+ rm -f $(TARGET_SUBDIR)/[+module+]/Makefile || : ; \
+ cp multilib.out $(TARGET_SUBDIR)/[+module+]/multilib.out
-[+ all prefix="target-" subdir="$(TARGET_SUBDIR)"
- exports="$(RAW_CXX_TARGET_EXPORTS)"
- args="$(TARGET_FLAGS_TO_PASS) 'CXX=$$(RAW_CXX_FOR_TARGET)' 'CXX_FOR_TARGET=$$(RAW_CXX_FOR_TARGET)'" +]
-[+ ELSE +]
-[+ configure prefix="target-" subdir="$(TARGET_SUBDIR)"
- check_multilibs=true
- exports="$(NORMAL_TARGET_EXPORTS)"
- args="$(TARGET_CONFIGARGS)" no-config-site=true +]
-
-[+ all prefix="target-" subdir="$(TARGET_SUBDIR)"
- exports="$(NORMAL_TARGET_EXPORTS)"
- args="$(TARGET_FLAGS_TO_PASS)" +]
-[+ ENDIF +]
+configure-target-[+module+]: $(TARGET_SUBDIR)/[+module+]/multilib.out
+ @test ! -f $(TARGET_SUBDIR)/[+module+]/Makefile || exit 0; \
+ $(SHELL) $(srcdir)/mkinstalldirs $(TARGET_SUBDIR)/[+module+] ; \
+ r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \[+
+IF raw_cxx +]
+ $(RAW_CXX_TARGET_EXPORTS) \[+
+ELSE normal_cxx +]
+ $(NORMAL_TARGET_EXPORTS) \[+
+ENDIF raw_cxx +]
+ echo Configuring in $(TARGET_SUBDIR)/[+module+]; \
+ cd "$(TARGET_SUBDIR)/[+module+]" || exit 1; \
+ case $(srcdir) in \
+ /* | [A-Za-z]:[\\/]*) topdir=$(srcdir) ;; \
+ *) topdir=`echo $(TARGET_SUBDIR)/[+module+]/ | \
+ sed -e 's,\./,,g' -e 's,[^/]*/,../,g' `$(srcdir) ;; \
+ esac; \
+ srcdiroption="--srcdir=$${topdir}/[+module+]"; \
+ libsrcdir="$$s/[+module+]"; \
+ rm -f no-such-file || : ; \
+ CONFIG_SITE=no-such-file $(SHELL) $${libsrcdir}/configure \
+ $(TARGET_CONFIGARGS) $${srcdiroption} \
+ --with-target-subdir="$(TARGET_SUBDIR)" [+extra_configure_flags+] \
+ || exit 1
+@endif target-[+module+]
+
+.PHONY: all-target-[+module+] maybe-all-target-[+module+]
+maybe-all-target-[+module+]:
+@if target-[+module+]
+TARGET-target-[+module+]=[+ IF target +][+target+][+ ELSE +]all[+ ENDIF target +]
+maybe-all-target-[+module+]: all-target-[+module+]
+all-target-[+module+]: configure-target-[+module+]
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \[+
+IF raw_cxx +]
+ $(RAW_CXX_TARGET_EXPORTS) \[+
+ELSE normal_cxx +]
+ $(NORMAL_TARGET_EXPORTS) \[+
+ENDIF raw_cxx +]
+ (cd $(TARGET_SUBDIR)/[+module+] && \
+ $(MAKE) $(TARGET_FLAGS_TO_PASS) [+
+ IF raw_cxx
+ +] 'CXX=$$(RAW_CXX_FOR_TARGET)' 'CXX_FOR_TARGET=$$(RAW_CXX_FOR_TARGET)' [+
+ ENDIF raw_cxx
+ +] [+extra_make_flags+] $(TARGET-target-[+module+]))
+@endif target-[+module+]
.PHONY: check-target-[+module+] maybe-check-target-[+module+]
maybe-check-target-[+module+]:
@@ -1001,7 +1052,6 @@ maybe-check-target-[+module+]: check-target-[+module+]
check-target-[+module+]:
[+ ELSE check +]
check-target-[+module+]:
- @: $(MAKE); $(unstage)
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \[+
IF raw_cxx +]
@@ -1027,7 +1077,6 @@ maybe-install-target-[+module+]: install-target-[+module+]
install-target-[+module+]:
[+ ELSE install +]
install-target-[+module+]: installdirs
- @: $(MAKE); $(unstage)
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \[+
IF raw_cxx +]
@@ -1054,7 +1103,6 @@ maybe-[+make_target+]-target-[+module+]: [+make_target+]-target-[+module+]
FOR depend +]\
[+depend+]-target-[+module+] [+
ENDFOR depend +]
- @: $(MAKE); $(unstage)
@[ -f $(TARGET_SUBDIR)/[+module+]/Makefile ] || exit 0 ; \
r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \[+
@@ -1196,42 +1244,42 @@ gcc-no-fixedincludes:
# stage_last instead tracks the stage that was built last. These targets
# are dummy when toplevel bootstrap is not active.
-# While making host and target tools, symlinks to the final stage must be
-# there, so $(unstage) should be run at various points. To avoid excessive
-# recursive invocations of make, we "inline" them using a variable. These
-# must be referenced as ": $(MAKE) ; $(unstage)" rather than "$(unstage)"
-# to avoid warnings from the GNU Make job server.
-
-unstage = :
-stage = :
-current_stage = ""
-
+.PHONY: unstage
+unstage:
@if gcc-bootstrap
-unstage = [ -f stage_current ] || $(MAKE) `cat stage_last`-start
-stage = if [ -f stage_current ]; then $(MAKE) `cat stage_current`-end || exit 1; else :; fi
-current_stage = "`cat stage_current 2> /dev/null`"
+ @[ -f stage_current ] || $(MAKE) `cat stage_last`-start
@endif gcc-bootstrap
-.PHONY: unstage stage
-unstage:
- @: $(MAKE); $(unstage)
+.PHONY: stage
stage:
- @: $(MAKE); $(stage)
-
-# Disable commands for lean bootstrap.
-LEAN = false
+@if gcc-bootstrap
+ @$(MAKE) `cat stage_current`-end
+@endif gcc-bootstrap
# We name the build directories for the various stages "stage1-gcc",
# "stage2-gcc","stage3-gcc", etc.
# Since the 'compare' process will fail (on debugging information) if any
# directory names are different, we need to link the gcc directory for
-# the previous stage to a constant name ('prev-gcc'), and to make the name of
+# the previous stage to a constant name ('gcc-prev'), and to make the name of
# the build directories constant as well. For the latter, we use naked names
# like 'gcc', because the scripts in that directory assume it. We use
# mv on platforms where symlinks to directories do not work or are not
# reliable.
+# At the end of the bootstrap, a symlink to 'stage3-gcc' named 'gcc' must
+# be kept, so that libraries can find it. Ick!
+
+# It would be best to preinstall gcc into a staging area (and in the
+# future, gather there all prebootstrap packages). This would allow
+# assemblers and linkers can be bootstrapped as well as the compiler
+# (both in a combined tree, or separately). This however requires some
+# change to the gcc driver, again in order to avoid comparison failures.
+
+# Bugs: This is crippled when doing parallel make, the `make all-host'
+# and `make all-target' phases can be parallelized.
+
+
# 'touch' doesn't work right on some platforms.
STAMP = echo timestamp >
@@ -1250,10 +1298,8 @@ objext = .o
# Flags to pass to stage2 and later makes.
POSTSTAGE1_FLAGS_TO_PASS = \
CC="$${CC}" CC_FOR_BUILD="$${CC_FOR_BUILD}" \
- STAGE_PREFIX=$$r/prev-gcc/ \
+ STAGE_PREFIX=$$r/stage[+prev+]-gcc/ \
CFLAGS="$(BOOT_CFLAGS)" \
- LIBCFLAGS="$(BOOT_CFLAGS)" \
- LDFLAGS="$(BOOT_LDFLAGS)" \
ADAC="\$$(CC)"
# For stage 1:
@@ -1269,129 +1315,150 @@ POSTSTAGE1_FLAGS_TO_PASS = \
.PHONY: stage[+id+]-start stage[+id+]-end
stage[+id+]-start::
- @: $(MAKE); $(stage); \
+ @[ -f stage_current ] && $(MAKE) `cat stage_current`-end || : ; \
echo stage[+id+] > stage_current ; \
echo stage[+id+] > stage_last; \
- $(SHELL) $(srcdir)/mkinstalldirs $(HOST_SUBDIR)[+
+ $(mkinstalldirs) $(HOST_SUBDIR)[+
FOR host_modules +][+ IF bootstrap +]
@if [+ module +]
@cd $(HOST_SUBDIR); [ -d stage[+id+]-[+module+] ] || \
mkdir stage[+id+]-[+module+]; \
- mv stage[+id+]-[+module+] [+module+] [+ IF prev +] ; \
- mv stage[+prev+]-[+module+] prev-[+module+] || test -f stage[+prev+]-lean [+ ENDIF prev +]
+ set stage[+id+]-[+module+] [+module+] ; \
+ @CREATE_LINK_TO_DIR@ [+ IF prev +] ; \
+ set stage[+prev+]-[+module+] prev-[+module+] ; \
+ @CREATE_LINK_TO_DIR@ [+ ENDIF prev +]
@endif [+ module +][+ ENDIF bootstrap +][+ ENDFOR host_modules +]
- @[ -d stage[+id+]-$(TARGET_SUBDIR) ] || \
- mkdir stage[+id+]-$(TARGET_SUBDIR); \
- mv stage[+id+]-$(TARGET_SUBDIR) $(TARGET_SUBDIR) [+ IF prev +] ; \
- mv stage[+prev+]-$(TARGET_SUBDIR) prev-$(TARGET_SUBDIR) || test -f stage[+prev+]-lean [+ ENDIF prev +]
-stage[+id+]-end:: [+ FOR host_modules +][+ IF bootstrap +]
+stage[+id+]-end::
+ @rm -f stage_current[+ FOR host_modules +][+ IF bootstrap +]
@if [+ module +]
- @if test -d $(HOST_SUBDIR)/[+module+] ; then \
- cd $(HOST_SUBDIR); mv [+module+] stage[+id+]-[+module+] [+ IF prev +]; \
- mv prev-[+module+] stage[+prev+]-[+module+] ; : [+ ENDIF prev +] ; \
- fi
+ @cd $(HOST_SUBDIR); set [+module+] stage[+id+]-[+module+] ; \
+ @UNDO_LINK_TO_DIR@ [+ IF prev +] ; \
+ set prev-[+module+] stage[+prev+]-[+module+] ; \
+ @UNDO_LINK_TO_DIR@ [+ ENDIF prev +]
@endif [+ module +][+ ENDIF bootstrap +][+ ENDFOR host_modules +]
- @if test -d $(TARGET_SUBDIR) ; then \
- mv $(TARGET_SUBDIR) stage[+id+]-$(TARGET_SUBDIR) [+ IF prev +] ; \
- mv prev-$(TARGET_SUBDIR) stage[+prev+]-$(TARGET_SUBDIR) ; : [+ ENDIF prev +] ; \
- fi
- rm -f stage_current
-# Bubble a bugfix through all the stages up to stage [+id+]. They are
-# remade, but not reconfigured. The next stage (if any) will not be
-# reconfigured as well.
+# Bubble a bugfix through all the stages up to stage [+id+]. They
+# are remade, but not reconfigured. The next stage (if any) will not
+# be reconfigured as well.
.PHONY: stage[+id+]-bubble
-stage[+id+]-bubble:: [+ IF prev +]stage[+prev+]-bubble[+ ENDIF +]
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- if test -f stage[+id+]-lean [+
+stage[+id+]-bubble:: [+ IF prev +]stage[+prev+]-bubble[+ ENDIF +][+IF lean +]
+ @bootstrap_lean@-rm -rf stage[+lean+]-* ; $(STAMP) stage[+lean+]-lean[+ ENDIF lean +]
+ @if test -f stage[+id+]-lean [+
IF prev +]|| test -f stage[+prev+]-lean [+ ENDIF prev +] ; then \
echo Skipping rebuild of stage[+id+] ; \
else \
- $(MAKE) stage[+id+]-start; \[+IF lean +]
- if $(LEAN); then \
- rm -rf stage[+lean+]-* ; \
- $(STAMP) stage[+lean+]-lean ; \
- fi; \[+ ENDIF lean +]
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) all-stage[+id+]; \
- fi[+ IF compare-target +]
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) [+compare-target+][+ ENDIF compare-target +]
+ $(MAKE) $(RECURSE_FLAGS_TO_PASS) NOTPARALLEL= all-stage[+id+]; \
+ fi
.PHONY: all-stage[+id+] clean-stage[+id+]
+all-stage[+id+]: [+ FOR host_modules +][+ IF bootstrap +]\
+ maybe-all-stage[+id+]-[+module+][+
+ENDIF bootstrap+] [+ ENDFOR host_modules +]
+
do-clean: clean-stage[+id+]
+clean-stage[+id+]: [+ FOR host_modules +][+ IF bootstrap +]\
+ maybe-clean-stage[+id+]-[+module+][+
+ENDIF bootstrap+] [+ ENDFOR host_modules +]
+
+[+ FOR host_modules +][+ IF bootstrap +]
+.PHONY: configure-stage[+id+]-[+module+] maybe-configure-stage[+id+]-[+module+]
+.PHONY: all-stage[+id+]-[+module+] maybe-all-stage[+id+]-[+module+]
+.PHONY: clean-stage[+id+]-[+module+] maybe-clean-stage[+id+]-[+module+]
+
+maybe-configure-stage[+id+]-[+module+]:
+maybe-all-stage[+id+]-[+module+]:
+maybe-clean-stage[+id+]-[+module+]:
+
+@if [+module+]-bootstrap
+maybe-configure-stage[+id+]-[+module+]: configure-stage[+id+]-[+module+]
+configure-stage[+id+]-[+module+]:
+ @$(MAKE) stage[+id+]-start
+ @[ -f [+module+]/Makefile ] && exit 0 || : ; \
+ r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; [+ IF prev +] \
+ $(STAGE_HOST_EXPORTS) [+ ELSE prev +] \
+ $(HOST_EXPORTS) [+ ENDIF prev +] \
+ echo Configuring stage [+id+] in [+module+] ; \
+ cd $(HOST_SUBDIR)/[+module+] || exit 1; \
+ case $(srcdir) in \
+ /* | [A-Za-z]:[\\/]*) topdir=$(srcdir) ;; \
+ *) topdir=`echo $(HOST_SUBDIR)/[+module+]/ | \
+ sed -e 's,\./,,g' -e 's,[^/]*/,../,g' `$(srcdir) ;; \
+ esac; \
+ srcdiroption="--srcdir=$${topdir}/[+module+]"; \
+ libsrcdir="$$s/[+module+]"; \
+ $(SHELL) $${libsrcdir}/configure \
+ $(HOST_CONFIGARGS) $${srcdiroption} \
+ [+stage_configure_flags+] [+extra_configure_flags+]
+
+maybe-all-stage[+id+]-[+module+]: all-stage[+id+]-[+module+]
+all-stage[+id+]-[+module+]: configure-stage[+id+]-[+module+]
+ @$(MAKE) stage[+id+]-start
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; [+ IF prev +] \
+ $(STAGE_HOST_EXPORTS) [+ ELSE prev +] \
+ $(HOST_EXPORTS) [+ ENDIF prev +] \
+ cd $(HOST_SUBDIR)/[+module+] && \
+ $(MAKE) $(FLAGS_TO_PASS) [+ IF prev +] \
+ $(POSTSTAGE1_FLAGS_TO_PASS) [+ ENDIF prev +] \
+ [+stage_make_flags+] [+extra_make_flags+]
+
+maybe-clean-stage[+id+]-[+module+]: clean-stage[+id+]-[+module+]
+clean-stage[+id+]-[+module+]:
+ @[ -f [+module+]/Makefile ] || [ -f stage[+id+]-[+module+]/Makefile ] \
+ || exit 0 ; \
+ [ -f [+module+]/Makefile ] || $(MAKE) stage[+id+]-start ; \
+ cd $(HOST_SUBDIR)/[+module+] && \
+ $(MAKE) $(FLAGS_TO_PASS) [+ IF prev +] \
+ $(POSTSTAGE1_FLAGS_TO_PASS) [+ ENDIF prev +] \
+ [+stage_make_flags+] [+extra_make_flags+] clean
+@endif [+module+]-bootstrap
+
+[+ ENDIF bootstrap +][+ ENDFOR host_modules +]
# FIXME: Will not need to be conditional when toplevel bootstrap is the
# only possibility, but now it conflicts with no-bootstrap rules
@if gcc-bootstrap
[+ IF compare-target +]
[+compare-target+]:
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- if test -f stage[+prev+]-lean; then \
+ @if test -f stage[+prev+]-lean; then \
echo Cannot compare object files as stage [+prev+] was deleted. ; \
exit 0 ; \
fi; \
- : $(MAKE); $(stage); \
+ [ -f stage_current ] && $(MAKE) `cat stage_current`-end || : ; \
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
rm -f .bad_compare ; \
- echo Comparing stages [+prev+] and [+id+] ; \
cd stage[+id+]-gcc; \
files=`find . -name "*$(objext)" -print` ; \
cd .. ; \
for file in $${files} ; do \
f1=$$r/stage[+prev+]-gcc/$$file; f2=$$r/stage[+id+]-gcc/$$file; \
@do_compare@ > /dev/null 2>&1; \
- if test $$? -eq 1; then \
- case $$file in \
- ./cc*-checksum$(objext) | ./libgcc/* ) \
- echo warning: $$file differs ;; \
- *) \
- echo $$file differs >> .bad_compare ;; \
- esac ; \
- fi ; \
+ test $$? -eq 1 && echo $$file differs >> .bad_compare || true; \
done ; \
if [ -f .bad_compare ]; then \
echo "Bootstrap comparison failure!"; \
cat .bad_compare; \
exit 1; \
else \
- echo Comparison successful.; \
+ true; \
fi ; \
$(STAMP) [+compare-target+][+ IF prev +]
- if $(LEAN); then \
- rm -rf stage[+prev+]-*; \
- $(STAMP) stage[+prev+]-lean; \
- fi[+ ENDIF prev +]
+ @bootstrap_lean@-rm -rf stage[+prev+]-* ; $(STAMP) stage[+prev+]-lean[+ ENDIF prev +]
[+ ENDIF compare-target +]
[+ IF bootstrap-target +]
-.PHONY: [+bootstrap-target+] [+bootstrap-target+]-lean
-[+bootstrap-target+]:
- echo stage[+id+] > stage_final
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) stage[+id+]-bubble
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(TARGET_FLAGS_TO_PASS) all-host all-target
-
-[+bootstrap-target+]-lean:
- echo stage[+id+] > stage_final
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) LEAN=: stage[+id+]-bubble
- @: $(MAKE); $(unstage)
- @r=`${PWD_COMMAND}`; export r; \
- s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- $(MAKE) $(TARGET_FLAGS_TO_PASS) all-host all-target
+.PHONY: [+bootstrap-target+]
+[+bootstrap-target+]: stage[+id+]-bubble [+compare-target+] all
[+ ENDIF bootstrap-target +]
# Rules to wipe a stage and all the following ones, also used for cleanstrap
[+ IF prev +]distclean-stage[+prev+]:: distclean-stage[+id+] [+ ENDIF prev +]
.PHONY: distclean-stage[+id+]
distclean-stage[+id+]::
- @: $(MAKE); $(stage)
+ [ -f stage_current ] && $(MAKE) `cat stage_current`-end || :
rm -rf stage[+id+]-* [+
IF compare-target +][+compare-target+] [+ ENDIF compare-target +]
@@ -1403,54 +1470,47 @@ distclean-stage[+id+]::
[+ ENDFOR bootstrap-stage +]
-stageprofile-end::
- $(MAKE) distclean-stagefeedback
-
stagefeedback-start::
@r=`${PWD_COMMAND}`; export r; \
s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
- for i in prev-*; do \
- j=`echo $$i | sed s/^prev-//` ; \
- cd $$r/$$i && \
- { find . -type d | sort | sed 's,.*,$(SHELL) '"$$s"'/mkinstalldirs "../'$$j'/&",' | $(SHELL) ; } && \
- { find . -name '*.*da' | sed 's,.*,$(LN) -f "&" "../'$$j'/&",' | $(SHELL) ; } ; \
- done
+ cd stageprofile-gcc && \
+ { find . -type d | sort | sed 's,.*,$(SHELL) '"$$s"'/mkinstalldirs "../gcc/&",' | $(SHELL); } && \
+ { find . -name '*.*da' | sed 's,.*,$(LN) -f "&" "../gcc/&",' | $(SHELL); }
+# FIXME: Will not need to be conditional when toplevel bootstrap is the
+# only possibility, but now it conflicts with no-bootstrap rules
@if gcc-bootstrap
-do-distclean: distclean-stage1
-
-# Provide a GCC build when we're building target libraries. This does
-# not work as a dependency, just as the minimum necessary to avoid errors.
-stage_last:
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) stage1-bubble
+profiledbootstrap:
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
+ $(HOST_EXPORTS) \
+ echo "Bootstrapping the compiler"; \
+ $(MAKE) stageprofile-bubble distclean-stagefeedback
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}` ; export s; \
+ echo "Building runtime libraries and training compiler"; \
+ $(MAKE) $(BASE_FLAGS_TO_PASS) $(RECURSE_FLAGS) all
+ @r=`${PWD_COMMAND}`; export r; \
+ s=`cd $(srcdir); ${PWD_COMMAND}`; export s; \
+ $(HOST_EXPORTS) \
+ echo "Building feedback based compiler"; \
+ $(MAKE) stagefeedback-bubble stagefeedback-end
@endif gcc-bootstrap
-.PHONY: restrap
-restrap:
- @: $(MAKE); $(stage)
- rm -rf stage1-$(TARGET_SUBDIR) [+ FOR bootstrap-stage +][+ IF prev
- +]stage[+id+] [+ ENDIF prev +][+ ENDFOR bootstrap-stage +]
- $(MAKE) $(RECURSE_FLAGS_TO_PASS) all
+@if gcc-bootstrap
+NOTPARALLEL = .NOTPARALLEL
+$(NOTPARALLEL):
+do-distclean: distclean-stage1
+@endif gcc-bootstrap
# --------------------------------------
# Dependencies between different modules
# --------------------------------------
# Generic dependencies for target modules on host stuff, especially gcc
-@if gcc-bootstrap[+ FOR target_modules +][+ IF bootstrap
- +][+ FOR bootstrap_stage +]
-configure-stage[+id+]-target-[+module+]: maybe-all-stage[+id+]-gcc[+
- ENDFOR +][+ ELSE bootstrap +]
-configure-target-[+module+]: stage_last[+
- ENDIF bootstrap +][+ ENDFOR target_modules +]
-@endif gcc-bootstrap
-
-@if gcc-no-bootstrap[+ FOR target_modules +][+ IF bootstrap
- +][+ ELSE +]
-configure-target-[+module+]: maybe-all-gcc[+
- ENDIF bootstrap +][+ ENDFOR target_modules +]
-@endif gcc-no-bootstrap
-
+[+ FOR target_modules +]
+configure-target-[+module+]: maybe-all-gcc
+[+ ENDFOR target_modules +]
[+ FOR lang_env_dependencies +]
configure-target-[+module+]: maybe-all-target-newlib maybe-all-target-libgloss
@@ -1516,6 +1576,7 @@ configure-target-[+module+]: maybe-all-target-newlib maybe-all-target-libgloss
"prebootstrap"
(if (or (= (dep-subtarget "on") "install-")
+ (=* (dep-module "on") "target-")
(not (hash-ref boot-modules (dep-module "module")))
(not (hash-ref boot-modules (dep-module "on"))))
"normal"
@@ -1529,10 +1590,6 @@ configure-target-[+module+]: maybe-all-target-newlib maybe-all-target-libgloss
(if (exist? "bootstrap")
(hash-create-handle! boot-modules (get "module") #t))
"" +][+ ENDFOR host_modules +]
-[+ FOR target_modules +][+
- (if (exist? "bootstrap")
- (hash-create-handle! boot-modules (string-append "target-" (get "module")) #t))
- "" +][+ ENDFOR target_modules +]
# With all the machinery above in place, it is pretty easy to generate
# dependencies. Host dependencies are a bit more complex because we have
@@ -1564,12 +1621,8 @@ all-prebootstrap: maybe-all-[+module+][+
ENDFOR host_modules +]
@endif gcc-no-bootstrap
-CONFIGURE_GDB_TK = @CONFIGURE_GDB_TK@
GDB_TK = @GDB_TK@
-INSTALL_GDB_TK = @INSTALL_GDB_TK@
-configure-gdb: $(CONFIGURE_GDB_TK)
all-gdb: $(gdbnlmrequirements) $(GDB_TK)
-install-gdb: $(INSTALL_GDB_TK)
# Serialization dependencies. Host configures don't work well in parallel to
# each other, due to contention over config.cache. Target configures and
@@ -1580,6 +1633,17 @@ install-gdb: $(INSTALL_GDB_TK)
# Regenerating top level configury
# --------------------------------
+# Multilib.out tells target dirs what multilibs they should build.
+# There is really only one copy. We use the 'timestamp' method to
+# work around various timestamp bugs on some systems.
+# We use move-if-change so that it's only considered updated when it
+# actually changes, because it has to depend on a phony target.
+multilib.out: maybe-all-gcc
+ @r=`${PWD_COMMAND}`; export r; \
+ echo "Checking multilib configuration..."; \
+ $(CC_FOR_TARGET) --print-multi-lib > multilib.tmp 2> /dev/null ; \
+ $(SHELL) $(srcdir)/move-if-change multilib.tmp multilib.out ; \
+
# Rebuilding Makefile.in, using autogen.
AUTOGEN = autogen
$(srcdir)/Makefile.in: @MAINT@ $(srcdir)/Makefile.tpl $(srcdir)/Makefile.def